package tech.nevets.vplus.blocks;

import net.fabricmc.fabric.api.object.builder.v1.block.FabricBlockSettings;
import net.minecraft.block.*;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;
import tech.nevets.vplus.items.VPItemGroups;

import java.util.ArrayList;
import java.util.List;

public class VPBlocks {
    public static final List<Block> BLOCKS = new ArrayList<>();

    public static final Block SAPPHIRE_ORE;
    public static final Block RUBY_ORE;
    public static final Block JADE_ORE;
    public static final Block SAPPHIRE_BLOCK;
    public static final Block RUBY_BLOCK;
    public static final Block JADE_BLOCK;
    public static final Block LAVA_SPONGE_BLOCK;
    public static final Block SATURATED_LAVA_SPONGE_BLOCK;
    
    // Vertical Slabs
    public static final Block VERTICAL_OAK_SLAB;
    public static final Block VERTICAL_SPRUCE_SLAB;
    public static final Block VERTICAL_BIRCH_SLAB;
    public static final Block VERTICAL_JUNGLE_SLAB;
    public static final Block VERTICAL_ACACIA_SLAB;
    public static final Block VERTICAL_DARK_OAK_SLAB;
    public static final Block VERTICAL_CRIMSON_SLAB;
    public static final Block VERTICAL_WARPED_SLAB;
    public static final Block VERTICAL_STONE_SLAB;
    public static final Block VERTICAL_SMOOTH_STONE_SLAB;
    public static final Block VERTICAL_SANDSTONE_SLAB;
    public static final Block VERTICAL_CUT_SANDSTONE_SLAB;
    public static final Block VERTICAL_COBBLESTONE_SLAB;
    public static final Block VERTICAL_BRICK_SLAB;
    public static final Block VERTICAL_STONE_BRICK_SLAB;
    public static final Block VERTICAL_NETHER_BRICK_SLAB;
    public static final Block VERTICAL_QUARTZ_SLAB;
    public static final Block VERTICAL_RED_SANDSTONE_SLAB;
    public static final Block VERTICAL_CUT_RED_SANDSTONE_SLAB;
    public static final Block VERTICAL_PURPUR_SLAB;
    public static final Block VERTICAL_PRISMARINE_SLAB;
    public static final Block VERTICAL_PRISMARINE_BRICK_SLAB;
    public static final Block VERTICAL_DARK_PRISMARINE_SLAB;
    public static final Block VERTICAL_POLISHED_GRANITE_SLAB;
    public static final Block VERTICAL_SMOOTH_RED_SANDSTONE_SLAB;
    public static final Block VERTICAL_MOSSY_STONE_BRICK_SLAB;
    public static final Block VERTICAL_POLISHED_DIORITE_SLAB;
    public static final Block VERTICAL_MOSSY_COBBLESTONE_SLAB;
    public static final Block VERTICAL_END_STONE_BRICK_SLAB;
    public static final Block VERTICAL_SMOOTH_SANDSTONE_SLAB;
    public static final Block VERTICAL_SMOOTH_QUARTZ_SLAB;
    public static final Block VERTICAL_GRANITE_SLAB;
    public static final Block VERTICAL_ANDESITE_SLAB;
    public static final Block VERTICAL_RED_NETHER_BRICK_SLAB;
    public static final Block VERTICAL_POLISHED_ANDESITE_SLAB;
    public static final Block VERTICAL_DIORITE_SLAB;
    public static final Block VERTICAL_BLACKSTONE_SLAB;
    public static final Block VERTICAL_POLISHED_BLACKSTONE_SLAB;
    public static final Block VERTICAL_POLISHED_BLACKSTONE_BRICK_SLAB;
    
    public VPBlocks() {
    }

    static {
        SAPPHIRE_ORE = register("sapphire_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        RUBY_ORE = register("ruby_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        JADE_ORE = register("jade_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        SAPPHIRE_BLOCK = register("sapphire_block", new Block(AbstractBlock.Settings.of(Material.METAL).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        RUBY_BLOCK = register("ruby_block", new Block(AbstractBlock.Settings.of(Material.METAL).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        JADE_BLOCK = register("jade_block", new Block(AbstractBlock.Settings.of(Material.METAL).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.BLOCKS).getBlock();
        LAVA_SPONGE_BLOCK = register("lava_sponge", new LavaSpongeBlock(), VPItemGroups.BLOCKS).getBlock();
        SATURATED_LAVA_SPONGE_BLOCK = register("saturated_lava_sponge", new SaturatedLavaSpongeBlock(), VPItemGroups.BLOCKS, new Item.Settings().recipeRemainder(Item.fromBlock(LAVA_SPONGE_BLOCK))).getBlock();
        
        // Vertical Slabs
        //TODO add new 1.17 blocks
        //TODO add new 1.18 blocks
        //TODO add new 1.19 blocks
        VERTICAL_OAK_SLAB = register("vertical_oak_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SPRUCE_SLAB = register("vertical_spruce_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_BIRCH_SLAB = register("vertical_birch_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_JUNGLE_SLAB = register("vertical_jungle_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_ACACIA_SLAB = register("vertical_acacia_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_DARK_OAK_SLAB = register("vertical_dark_oak_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_CRIMSON_SLAB = register("vertical_crimson_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_WARPED_SLAB = register("vertical_warped_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.WOOD).sounds(BlockSoundGroup.WOOD).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_STONE_SLAB = register("vertical_stone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SMOOTH_STONE_SLAB = register("vertical_smooth_stone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SANDSTONE_SLAB = register("vertical_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_CUT_SANDSTONE_SLAB = register("vertical_cut_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_COBBLESTONE_SLAB = register("vertical_cobblestone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_BRICK_SLAB = register("vertical_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_STONE_BRICK_SLAB = register("vertical_stone_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_NETHER_BRICK_SLAB = register("vertical_nether_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_QUARTZ_SLAB = register("vertical_quartz_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_RED_SANDSTONE_SLAB = register("vertical_red_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_CUT_RED_SANDSTONE_SLAB = register("vertical_cut_red_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_PURPUR_SLAB = register("vertical_purpur_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_PRISMARINE_SLAB = register("vertical_prismarine_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_PRISMARINE_BRICK_SLAB = register("vertical_prismarine_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_DARK_PRISMARINE_SLAB = register("vertical_dark_prismarine_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_POLISHED_GRANITE_SLAB = register("vertical_polished_granite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SMOOTH_RED_SANDSTONE_SLAB = register("vertical_smooth_red_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_MOSSY_STONE_BRICK_SLAB = register("vertical_mossy_stone_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_POLISHED_DIORITE_SLAB = register("vertical_polished_diorite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_MOSSY_COBBLESTONE_SLAB = register("vertical_mossy_cobblestone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_END_STONE_BRICK_SLAB = register("vertical_end_stone_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SMOOTH_SANDSTONE_SLAB = register("vertical_smooth_sandstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_SMOOTH_QUARTZ_SLAB = register("vertical_smooth_quartz_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_GRANITE_SLAB = register("vertical_granite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_ANDESITE_SLAB = register("vertical_andesite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_RED_NETHER_BRICK_SLAB = register("vertical_red_nether_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_POLISHED_ANDESITE_SLAB = register("vertical_polished_andesite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_DIORITE_SLAB = register("vertical_diorite_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_BLACKSTONE_SLAB = register("vertical_blackstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_POLISHED_BLACKSTONE_SLAB = register("vertical_polished_blackstone_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();
        VERTICAL_POLISHED_BLACKSTONE_BRICK_SLAB = register("vertical_polished_blackstone_brick_slab", new VerticalSlabBlock(FabricBlockSettings.of(Material.STONE).sounds(BlockSoundGroup.STONE).hardness(2.0F)), VPItemGroups.BLOCKS).getBlock();

        ///////////////////\\\\ITERATOR////\\\\\\\\\\\\\\\\\\\

        for (Block block : BLOCKS) {
            for (BlockState blockState : block.getStateManager().getStates()) {
                Block.STATE_IDS.add(blockState);
            }
            block.getLootTableId();
        }
    }

    /*
    Use blockItem.getBlock(); to get instance of the block if needed
     */
    private static BlockItem register(String id, Block block, ItemGroup group) {
        Registry.register(Registry.BLOCK, new Identifier("vplus", id), block);
        BLOCKS.add(block);
        return Registry.register(Registry.ITEM, new Identifier("vplus", id), new BlockItem(block, new Item.Settings().group(group)));
    }

    private static BlockItem register(String id, Block block, ItemGroup group, Item.Settings itemSettings) {
        Registry.register(Registry.BLOCK, new Identifier("vplus", id), block);
        BLOCKS.add(block);
        return Registry.register(Registry.ITEM, new Identifier("vplus", id), new BlockItem(block, itemSettings.group(group)));
    }

    public static void init() {}
}
